function rand(low, hi){
	return Math.floor(Math.random() * (hi - low + 1))+low;
}

function randomElementOf(array){
    return array[Math.floor(Math.random()*array.length)];
}

function distance(x1, y1, x2, y2) {
    return Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
}

function flatDistance(x1, y1, x2, y2){
	var xDist = Math.abs(x1 - x2);
	var yDist = Math.abs(y1 - y2);
	if (xDist === yDist)
		return xDist;
	else
		return xDist + yDist;
}

function lineDistance( point1, point2 ){
  var xs = 0;
  var ys = 0;
  xs = point2.x - point1.x;
  xs = xs * xs;
  ys = point2.y - point1.y;
  ys = ys * ys;
  return Math.sqrt( xs + ys );
}

function direction(a,b){
	return {x: sign(b.x - a.x), y: sign(b.y - a.y)};
}

function randomDirection(){
    return {x: rand(-1,1), y: rand(-1,1)};
}

function getAlternateDirections(direction){
	if (direction === 0 && direction.y === 0)
		return {a1: direction, a2: direction};
	var side1 = direction;
	var side2 = direction;
	if (direction.x === 0){
		side1 = {x: - 1, y: direction.y};
		side2 = {x: + 1, y: direction.y};
	} else if (direction.y === 0){
		side1 = {x: direction.x, y: - 1};
		side2 = {x: direction.x, y: + 1};
	} else {
		//  x+
		//  +@
		side1 = {x: direction.x, y: 0};
		side2 = {x: 0, y: direction.y};
	}
	return {a1: side1, a2: side2};
}

function getSideDirections(direction){
	if (direction === 0 && direction.y === 0)
		return {a1: direction, a2: direction};
	var side1 = direction;
	var side2 = direction;
	if (direction.x === 0){
		side1 = {x: - 1, y: 0};
		side2 = {x: + 1, y: 0};
	} else if (direction.y === 0){
		side1 = {x: 0, y: - 1};
		side2 = {x: 0, y: + 1};
	} else {
		//  x+
		//  +@
		side1 = {x: direction.x, y: 0};
		side2 = {x: 0, y: direction.y};
	}
	return {a1: side1, a2: side2};
}

function sign (a){
	if (a > 0)
		return 1;
	else if (a < 0)
		return -1;
	else
		return 0;
}

var DIRECTIONS = ["UP", "DOWN", "LEFT", "RIGHT"];

var ALL_DIRECTIONS = ["UP", "DOWN", "LEFT", "RIGHT","UPLEFT", "DOWNLEFT", "UPRIGHT", "DOWNRIGHT"];


//Array Remove - By John Resig (MIT Licensed)
Array.prototype.remove = function(from, to) {
  var rest = this.slice((to || from) + 1 || this.length);
  this.length = from < 0 ? this.length + from : from;
  return this.push.apply(this, rest);
};

Array.prototype.removeObject = function(object) {
	for (var i = 0; i < this.length; i++){
		if (this[i] == object){
			this.remove(i,i);
			return;
		}
	}
};

Array.prototype.contains = function(element){
    return this.indexOf(element) > -1;
};

function chance(chance){
	return rand(0,100) <= chance;
}

Math.PI2 = Math.PI * 2;

/**
 * 
 * @autor: kram
 */
Math.getAngle = function(/*vec2*/ a, /*vec2*/ b){
	var xx = Math.abs(a.x - b.x);
	var yy = Math.abs(a.y - b.y);
	
	var ang = Math.atan2(yy, xx);
	
	if (b.x <= a.x && b.y <= a.y){
		ang = Math.PI - ang;
	}else if (b.x <= a.x && b.y > a.y){
		ang = Math.PI + ang;
	}else if (b.x > a.x && b.y > a.y){
		ang = Math.PI2 - ang;
	}
	
	ang = (ang + Math.PI2) % Math.PI2;
	
	return ang;
};

Math.getAngle2 = function(x1, y1, x2, y2){
	var xx = Math.abs(x1 - x2);
	var yy = Math.abs(y1 - y2);
	
	var ang = Math.atan2(yy, xx);
	
	if (x2 <= x1 && y2 <= y1){
		ang = Math.PI - ang;
	}else if (x2 <= x1 && y2 > y1){
		ang = Math.PI + ang;
	}else if (x2 > x1 && y2 > y1){
		ang = Math.PI2 - ang;
	}
	
	ang = (ang + Math.PI2) % Math.PI2;
	
	return ang;
};

function getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}